import React from 'react';
import injectTapEventPlugin from 'react-tap-event-plugin';
import _ from 'lodash';

import { render } from 'react-dom';

import {
  InputButtonGroup,
  InputCity,
  InputDate,
  InputTime,
  InputInteger,
  InputMobile,
  InputPassword,
  InputSelect,
  InputSelectOption,
  InputText,
  InputToggle,
} from './index'

injectTapEventPlugin();

class Dev extends React.Component {

  input = {};

  componentWillMount() {
    this.setState(_.mapValues({
      name: '姓名',
      max: '額度',
      mobile: '聯絡電話',
      password: '密碼',
      city: '居住城市',
      birthday: '生日',
      booking: '預約時間',
      plan: '方案',
      enable: '通知',
    }, (display, key) => {
      this.input[key] = {
        label: display,
        value: null,
        error: null,
        onChange: (value, error) => {
          const state = {};
          state[key] = this.state[key];
          state[key].value = value;
          state[key].error = error && display + error;

          this.setState(state);
        },
      };

      return this.input[key];
    }));
  }

  onSubmit = () => {
    const error = [];
    const data = {};

    _.each(this.input, (input, key) => {
      if (input.error) error.push(input.error);
      else data[key] = input.value;
    });

    console.log(error);
    console.log(data);
  }

  render() {
    const {
      name,
      max,
      mobile,
      password,
      city,
      birthday,
      booking,
      plan,
      enable,
    } = this.state;

    return (
      <div>
        <InputButtonGroup {...plan} required>
          <button value="1">01</button>
          <button value="2">02</button>
          <button value="3">03</button>
          <button value="4">04</button>
        </InputButtonGroup>
        <InputText {...name} required />
        <InputInteger {...max} required />
        <InputMobile {...mobile} required />
        <InputPassword {...password} required />
        <InputCity {...city} required />
        <InputDate {...birthday} required />
        <InputTime {...booking} required />
        <InputToggle {...enable} />
        <button
          style={{
            width: '100%',
            height: 42,
            fontSize: 16,
          }}
          onClick={this.onSubmit}
        >送出表單</button>
      </div>
    );
  }
}

render(React.createElement(Dev), document.getElementById('dev'));