import React, {PropTypes, cloneElement} from 'react';
import c from 'classnames';
import { mapPropsOnChange } from 'recompose';

import InputText from '../input-text/input-text'

@mapPropsOnChange(
  ['value'],
  ({value, defaultText, ...props}) => ({
    text: value && value.toString() || defaultText,
    ...props,
  })
)
export default class extends React.Component {
  displayName: 'InputInteger'
  
  static propTypes = {
    value: PropTypes.number,
    defaultText: PropTypes.string,
  }

  validate(value) {
    const { required, onChange } = this.props;

    return required && value === 0 ? '是必須大於零' : null;
  }
  
  onChange = (value, error, e) => {
    value = value && parseInt(value.replace(/[^0-9]/gi,'').replace(/^0/,'')) || 0;

    this.props.onChange(value, error || this.validate(value), e);
  }

  render () {
    const {
      onChange,
      value,
      text,
      ...otherProps,
    } = this.props;

    return (
      <InputText {...otherProps} onChange={this.onChange} value={text} type="tel" />
    );
  }
}
