import React, {PropTypes, cloneElement} from 'react';
import c from 'classnames';

import InputText from '../input-text/input-text'

export default class extends React.Component {
  displayName: 'InputMobile'

  validate(value) {
    return value && !/^0[0-9]{9}$/gi.test(value) ? '必須是10碼且開頭為0的號碼' : null;
  }
  
  onChange = (value, error, e) => {
    this.props.onChange(value, error || this.validate(value), e);
  }

  render () {
    const {
      onChange,
      ...otherProps,
    } = this.props;

    return (
      <InputText {...otherProps} onChange={this.onChange} type="tel" />
    );
  }
}
