import React, {PropTypes, cloneElement} from 'react';
import c from 'classnames';

import InputText from '../input-text/input-text'

export default class extends React.Component {
  displayName: 'InputPassword'

  validate(value) {
    return value && value.length < 6 ? '的長度必須6個以上' : null;
  }
  
  onChange = (value, error, e) => {
    this.props.onChange(value, error || this.validate(value), e);
  }

  render () {
    const {
      onChange,
      ...otherProps,
    } = this.props;

    return (
      <InputText {...this.props} onChange={this.onChange} />
    );
  }
}
