import React, {PropTypes} from 'react';
import c from 'classnames';
import InputText from '../input-text/input-text';

import style from './input-select.css';

export default class extends React.Component {
  displayName: 'InputSelect'
  
  static propTypes = {
    className: PropTypes.string,
    value: PropTypes.string.isRequired,
  }

  render() {
    const {
      className,
      children,
      value,
      ...otherProps,
    } = this.props;

    return (
      <option {...otherProps} key={`option-${value}`} value={value} className={style.option}>
        {children}
      </option>
    );
  }
}